(function() {
  if (!this.require) {
    var modules = {}, cache = {};

    var require = function(name, root) {
      var path = expand(root, name), indexPath = expand(path, './index'), module, fn;
      module   = cache[path] || cache[indexPath];
      if (module) {
        return module;
      } else if (fn = modules[path] || modules[path = indexPath]) {
        module = {id: path, exports: {}};
        cache[path] = module.exports;
        fn(module.exports, function(name) {
          return require(name, dirname(path));
        }, module);
        return cache[path] = module.exports;
      } else {
        throw 'module ' + name + ' not found';
      }
    };

    var expand = function(root, name) {
      var results = [], parts, part;
      // If path is relative
      if (/^\.\.?(\/|$)/.test(name)) {
        parts = [root, name].join('/').split('/');
      } else {
        parts = name.split('/');
      }
      for (var i = 0, length = parts.length; i < length; i++) {
        part = parts[i];
        if (part == '..') {
          results.pop();
        } else if (part != '.' && part != '') {
          results.push(part);
        }
      }
      return results.join('/');
    };

    var dirname = function(path) {
      return path.split('/').slice(0, -1).join('/');
    };

    this.require = function(name) {
      return require(name, '');
    };

    this.require.define = function(bundle) {
      for (var key in bundle) {
        modules[key] = bundle[key];
      }
    };

    this.require.modules = modules;
    this.require.cache   = cache;
  }

  return this.require;
}).call(this);
this.require.define({"app/models/property":function(exports, require, module){(function() {
  var Collection, Property, Serialize, Values,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor; child.__super__ = parent.prototype; return child; };

  Collection = require('lib/collection');

  Serialize = require('./serialize').Serialize;

  Values = (function(_super) {

    __extends(Values, _super);

    Values.name = 'Values';

    function Values() {
      return Values.__super__.constructor.apply(this, arguments);
    }

    Values.prototype.toString = function() {
      return this.join(', ');
    };

    return Values;

  })(Collection);

  Property = (function(_super) {

    __extends(Property, _super);

    Property.name = 'Property';

    function Property() {
      return Property.__super__.constructor.apply(this, arguments);
    }

    Property.include(Serialize);

    Property.prototype.valueOf = function() {
      return this.toString();
    };

    return Property;

  })(Spine.Module);

  module.exports = Property;

  module.exports.Values = Values;

}).call(this);
;}});
